require 'date'

module DohWeb

def flatten_multi_param(map)
  if map.key?('hour') || map.key?('minute') || map.key?('second')
    DateTime.new(map['year'].to_i, map['month'].to_i, map['day'].to_i, map['hour'].to_i, map['minute'].to_i, map['second'].to_i) rescue nil
  elsif map.key?('year') || map.key?('month') || map.key?('day')
    Date.new(map['year'].to_i, map['month'].to_i, map['day'].to_i) rescue nil
  else
    map.to_s
  end
end

def group_params(group, _params = nil)
  prefix = "#{group}_"
  prefix_size = prefix.size
  retval = {}

  # first, go through all params to get the group ones, and combine the multi params ones into hashes
  (_params || params).each_pair do |key, value|
    next unless key.start_with?(prefix)
    key = key.slice(prefix_size..-1)

    unless key.index('__')
      retval[key] = value
      next
    end

    key, _, subkey = key.partition('__')
    raise "missing subkey for multi part param #{key}" if subkey.empty?
    parts = (retval[key] ||= {})
    parts[subkey] = value
  end

  # now, go back through and flatten all the multi part params into a single value object
  retval.each_pair do |key, value|
    retval[key] = flatten_multi_param(value) if value.is_a?(Hash)
  end

  retval
end

end
